; Module 'auto_sprite'
;
; Fait apparaitre les sprites qui sont en bordure de l'ecran.

; Call : 
;INIT_NEW_SPRITE	a4,A_INC
A_INC		EQU	1
A_NO_INC	EQU	0
INIT_NEW_SPRITE	MACRO
	move.l	\1,d3
	sub.l	Test_adr(a6),d3		; D3 = Offset
	ifne	\2
	subq.w	#1,d3			; Since we use (a4)+
	endif
	cmp.w	Sub_lev_size(a6),d3	; Test if we are outside the tab
	bcc.s	\@no_init
	clr.b	-\2(\1)			; Clear Tab[X_Init,Y_Init]
	move.w	d3,d1
	lsr.w	d7,d1
	lsl.w	#4,d1			; D1 = Y coordinate
	move.w	d3,d0
	and.w	Mask_x(a6),d0
	lsl.w	#4,d0			; D0 = X coordinate
	bsr	Init_sprite
\@no_init
		ENDM

; CHECK_HOR 0
CHECK_HOR	MACRO
	move.w	d0,Plane_A_Xs_old(a6)

	move.l	Test_adr(a6),a0		; A0 -> Test matrix
	lea	Object_table(Pc),a4
	move.w	PLANE_XS(a5),d0
	move.w	PLANE_YS(a5),d1

	CALC_OFFSET			; Calculate the offset in d0
	\1

	moveq	#0,d4
	move.w	Len_x(a6),d4		; For add / sub

	moveq	#(SCREEN_Y/16+2-1),d5
\@loop:	moveq	#0,d2
	move.b	(a0),d2			; Read test
	lsl.w	#2,d2
	move.w	2(a4,d2.w),d2		; Read the sprite which is associated with this test
	beq.s	\@no
	INIT_NEW_SPRITE a0,A_NO_INC
\@no:	add.l	d4,a0
	dbf.s	d5,\@loop
		ENDM

CHECK_VER	MACRO
	move.w	d0,Plane_A_Ys_old(a6)

	move.l	Test_adr(a6),a0		; A0 -> Test matrix
	lea	Object_table(Pc),a4
	move.w	PLANE_XS(a5),d0
	move.w	PLANE_YS(a5),d1
	CALC_OFFSET			; Calculate the offset in d0
	\1
	add.w	d0,a0

	moveq	#(SCREEN_X/2+2-1),d5
\@loop:	moveq	#0,d2
	move.b	(a0)+,d2		; Read test
	lsl.w	#2,d2
	move.w	2(a4,d2.w),d2		; Read the sprite which is associated with this test
	beq.s	\@no
	INIT_NEW_SPRITE a0,A_INC
\@no:	dbf.s	d5,\@loop
		ENDM

; Auto-sprites : init all the screen.
Init_all_sprites:
	bsr	gere_scrolling
	move.l	d5,-(a7)

	move.l	Plan_A_adr(a6),a0

	move.l	Test_adr(a6),a4		; A4 -> Test matrix
	lea	Object_table(Pc),a5
	move.w	PLANE_XS(a0),d0
	move.w	PLANE_YS(a0),d1
	CALC_OFFSET			; Calculate the offset in d0
	adda.w	d0,a4

	moveq	#(SCREEN_Y/16+2-1),d5
auto_spr_loop_y:
	moveq	#(SCREEN_X/2+2-1),d4
auto_spr_loop_x:
	moveq	#0,d2
	move.b	(a4)+,d2		; Read test
	lsl.w	#2,d2
	move.w	2(a5,d2.w),d2		; Read the sprite which is associated with this test
	beq.s	auto_spr_no
	INIT_NEW_SPRITE a4,A_INC
auto_spr_no:
	dbf.s	d4,auto_spr_loop_x
	move.w	Len_x(a6),d2
	lea	-(SCREEN_X/2+2)(a4,d2.w),a4
	dbf.s	d5,auto_spr_loop_y

	move.l	(a7)+,d5
	rts

Check_new_sprites:
	move.l	Plan_A_adr(a6),a5

	move.w	PLANE_XS(a5),d0
	and.w	#$FFF0,d0

	cmp.w	Plane_A_Xs_old(a6),d0
	beq	Check_vertical
	bgt.s	Check_right
Check_left:
	CHECK_HOR	<add.w	d0,a0>
	bra.s	Check_vertical
Check_right:
	CHECK_HOR	<lea	(SCREEN_X/2+1)(a0,d0.w),a0>
Check_vertical:
	move.w	PLANE_YS(a5),d0
	and.w	#$FFF0,d0
	cmp.w	Plane_A_Ys_old(a6),d0
	beq	Check_end
	bgt.s	Check_down
Check_up:
	CHECK_VER	<NOTHING>
	rts
Check_down:
	CHECK_VER	<add.w Check_offset(a6),d0>
Check_end:
	rts
