; *********************************************************************
; 				Internal macros.
; *********************************************************************
; C'est le coeur du systme !

; Nothing macro usefull :)
NOTHING		MACRO
		ENDM

; IN:  d0 = x, d1 = y
; OUT: d2.b = type
read	MACRO
	move.w	d0,-(a7)
	move.w	d1,-(a7)
	move.l	Test_adr(a6),a0
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.b	0(a0,d0.w),d2
	move.w	(a7)+,d1
	move.w	(a7)+,d0
	ENDM

; IN:  d0 = x, d1 = y & a0 -> test_adr
; OUT: d2.b = type, d0.W = offset and d1.w=d1*2^d7
read_destroy	MACRO
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.b	0(a0,d0.w),d2
	ENDM

; IN:  d0 = x, d1 = y & as -> Test_adr
; OUT: d2.b = type
; Example : read_as a0
read_as	MACRO
	move.w	d0,-(a7)
	move.w	d1,-(a7)
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.b	0(\1,d0.w),d2
	move.w	(a7)+,d1
	move.w	(a7)+,d0
	ENDM

; IN:  d0 = x, d1 = y & as -> test_adr
; OUT: d2.b = type, d0.w = Offset and d1 destroy
; Example: read_destroy a0
read_destroy_as	MACRO
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.b	0(\1,d0.w),d2
	ENDM

; IN:  d0 = x, d1 = y & as -> test_adr
; OUT: d2.b = type, d0.w = Offset
; Example: read_destroy a0
read_destroy_d0_as	MACRO
	move.w	d1,-(a7)
	lsr.w	#4,d1
	lsr.w	#4,d0
	lsl.w	d7,d1
	add.w	d1,d0
	move.w	(a7)+,d1
	move.b	0(\1,d0.W),d2
			ENDM
			
; IN:  x, y & as -> test_adr
; OUT: ?.b = type, x.w = Offset
; Example: read_free d0(=x),d1(=y),d2(=type),a4
read_free	MACRO
	lsr.w	#4,\2
	lsr.w	#4,\1
	lsl.w	d7,\2
	add.w	\2,\1
	move.b	0(\4,\1.w),\3
			ENDM


; IN:  d0 = x, d1 = y & as -> Test_adr
; OUT: d2.b = type
; Example : read_as a0
read_a4	MACRO
	read_as.\0 a4
	ENDM
; IN:  d0 = x, d1 = y & as -> test_adr
; OUT: d2.b = type and d0-d1 destroy
; Example: read_destroy a0
read_destroy_a4	MACRO
	read_destroy_as.\0 a4
	ENDM

; IN : d0, d1
; Read data in d3 and let in d2 the offset
read_for_test	MACRO
	move.w	d0,-(a7)
	move.w	d1,-(a7)
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.w	d0,d2
	move.b	0(a4,d2.w),d3
	move.w	(a7)+,d1
	move.w	(a7)+,d0
		ENDM

; Calculate the offset
CALC_OFFSET	MACRO
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
		ENDM


; CALL:  
;  test_collision x1,y1,mx1,my1,x2,y2,mx2,my2,label_if_no_collision
; x2 and y2 should be register and will be detroy.
; mx1 -> my2 : immediate value
; Destroy : x2 and y2
test_collision	MACRO
	sub.w	\1,\5
	bge.s	\@Ok
	neg.w	\5
\@Ok:	cmp.w	#((\3+\7)/2),\5
	bhi.\0	\9
	sub.w	\2,\6
	bge.s	\@Ok2
	neg.w	\6
\@Ok2:	cmp.w	#((\4+\8)/2),\6
	bhi.\0	\9
		ENDM

; test_sonic_collision x, y, mx, my, ds, label_if_no_collision
; ds is a temporary register which will be destroy
; x and y must be registers / will be destroy
test_sonic_collision	MACRO
	move.l	d6,\5
	swap	\5
	test_collision.\0 \5,d6,16,32,\1,\2,\3,\4,\6
			ENDM
; test_sonic_collision x, y, mx, my, ds, ds2, label_if_no_collision
; ds is a temporary register which will be destroy
test_sonic_collision2	MACRO
	move.l	d6,\5
	swap	\5
	move.w	d6,\6
	test_collision.\0 \1,\2,\3,\4,\5,\6,16,32,\7
			ENDM

; test_mur <read>,label_if_mur
; Destroy d2
test_mur	MACRO
	\1.\0
	cmp.b	Plan_mur(a6),d2
	beq.\0	\2
	subq.b	#1,d2
	beq.\0	\2
		ENDM

; test_mur <read>,label_if_no_mur
; Destroy d2
test_mur2	MACRO
	\1.\0
	cmp.b	Plan_mur(a6),d2
	beq.s	\@lab
	subq.b	#1,d2
	bne.\0	\2
\@lab:
		ENDM

; Test Sprite exit of the screen
; test_exit_screen x,y,ds,label_if_exit
; ds is a temporary register
test_exit_screen	MACRO
 test_sonic_collision.\0 \1,\2,2*240,128*2,\3,\4
			ENDM

; Search SIN
; search_SIN dx,ax,ds,label_if_not_found
; dx.l = SIN, ds = temp register
; Out : If success, ax -> Sprite with the good SIN
search_SIN	MACRO
	move.l	Sprite_ADR(a6),\2
	move.l	Sprite_end_ADR(a6),\3
	adda.w	#SIN,\2
\@loop:	cmp.l	(\2),\1
	beq.s	\@found
	adda.w	Taille(\2),\2
	cmp.l	\2,\3
	bhi.s	\@loop
	bra.\0	\4
\@found:
	suba.w	#SIN,\2
		ENDM

; Double buffer macro
; Make a swap between the diferrent dscreens.
;Destroy : d0-d1
DOUBLE_BUFFER	MACRO
	move.w	Select_s(a6),d1		; Read temps
	move.l	Screen_1(a6,d1.w),d0	; Read a screen
	jsr	genlib::set_dscreen_int	; Set the interrupt to this Dscreen
	eor.w	#4,d1			; Next screen
	move.l	Screen_1(a6,d1.w),d0	; Read the other screen
	move.l	d0,Current_dscreen(a6)	; Save it.
	jsr	genlib::set_dscreen_function	; Set the functions to this DScreen
	move.w	d1,Select_s(a6)		; Save temps
		ENDM

; Call : filtre_surface label_if no_surface
;	d2.b = type
;	Flag must be set to d2
; Example :
;	tst.b d2
;	filtre_surface if_no_surface
; Surface : 0 < d2 < MAX_SURFACE ou Plan_min < d2 < Plan_max
;filtre_surface	MACRO
;	beq.\0	\1
;	cmp.b	Plan_max(a6),d2
;	bcc.\0	\1
;	cmp.b	#MAX_SURFACE,d2
;	blt.s	\@label
;	sub.b	Plan_min(a6),d2
;	ble.\0	\1
;\@label:
;		ENDM
filtre_surfa	MACRO
	move.l	Current_surfa(a6),a0
	move.b	0(a0,d2.w),d2
	beq.\0	\1
		ENDM
filtre_surfb	MACRO
	move.l	Current_surfb(a6),a0
	move.b	0(a0,d2.w),d2
	beq.\0	\1
		ENDM
filtre_surfc	MACRO
	move.l	Current_surfc(a6),a0
	move.b	0(a0,d2.w),d2
	beq.\0	\1
		ENDM
filtre_surfd	MACRO
	move.l	Current_surfd(a6),a0
	move.b	0(a0,d2.w),d2
	beq.\0	\1
		ENDM









; Calcul de la vitesse
; calcul_vitesse <boule_macro>,<left_macro>,<right_macro>,<nokey_macro>
; D4 = key !
; Return : UpDate V (and ? Abs_V), d2 = V
; Les differentes routines sont identiques sauf qu'elles sont optimises en taille.
calcul_vitesse_long	MACRO
	move.l	V(a5),d2
	tst.b	Boule(a5)
	beq.s	\@No_boule
	\1.\0
	bra.\0	\@end
\@No_boule:
	btst.l	#left_key,d4
	bne.s	\@no_left
	cmp.l	#-MAX_F_SPEED,d2
	ble.\0	\@end
	\2.\0
	bra.s	\@end
\@no_left:
	btst.l	#right_key,d4
	bne.s	\@no_right
	cmp.l	#MAX_F_SPEED,d2
	bge.s	\@end
	\3.\0
	bra.s	\@end
\@no_right:
	\4.\0
\@end:	move.l	d2,V(a5)
		ENDM

calcul_vitesse_medium	MACRO
	move.l	V(a5),d2
	tst.b	Boule(a5)
	beq.s	\@No_boule
	\1.\0
	bra	\@end
\@No_boule:
	btst.l	#left_key,d4
	bne.s	\@no_left
	cmp.l	#-MAX_F_SPEED,d2
	ble.s	\@end
	\2.\0
	bra.s	\@end
\@no_left:
	btst.l	#right_key,d4
	bne.s	\@no_right
	cmp.l	#MAX_F_SPEED,d2
	bge.s	\@end
	\3.\0
	bra.s	\@end
\@no_right:
	\4.\0
\@end:	move.l	d2,V(a5)
		ENDM

calcul_vitesse	MACRO
	move.l	V(a5),d2
	tst.b	Boule(a5)
	beq.s	\@No_boule
	\1.\0
	bra.s	\@end
\@No_boule:
	btst.l	#left_key,d4
	bne.s	\@no_left
	cmp.l	#-MAX_F_SPEED,d2
	ble.s	\@end
	\2.\0
	bra.s	\@end
\@no_left:
	btst.l	#right_key,d4
	bne.s	\@no_right
	cmp.l	#MAX_F_SPEED,d2
	bge.s	\@end
	\3.\0
	bra.s	\@end
\@no_right:
	\4.\0
\@end:	move.l	d2,V(a5)
		ENDM

; calcul_vitesse2 <left_macro>,<right_macro>
calcul_vitesse2	MACRO
	move.l	V(a5),d2
	btst.l	#left_key,d4
	bne.s	\@no_left
	cmp.l	#-MAX_F_SPEED,d2
	ble.s	\@end
	\1
	bra.s	\@end
\@no_left:
	btst.l	#right_key,d4
	bne.s	\@no_right
	cmp.l	#MAX_F_SPEED,d2
	bge.s	\@end
	\2
\@no_right:
\@end:	move.l	d2,V(a5)
		ENDM

left_macro	MACRO
	move.l	d2,d0
	swap	d0
	and.w	#(-3-1),d0
	lea	Inc_Vitesse(Pc),a0
	sub.l	0(a0,d0.w),d2
		ENDM

right_macro	MACRO
	move.l	d2,d0
	swap	d0
	and.w	#(-3-1),d0
	lea	Inc_Vitesse(Pc),a0
	add.l	0(a0,d0.w),d2
		ENDM

left_fall_macro	MACRO
	move.l	d2,d1
	ble.s	\@lok
	sub.l	#FREIN_FALL_POW,d2
	bra.s	\@end
\@lok:	left_macro
	neg.l	d1
\@end:	move.l	d1,Abs_v(a5)
		ENDM

right_fall_macro	MACRO
	move.l	d2,d1
	bge.s	\@rok
	neg.l	d1
	add.l	#FREIN_FALL_POW,d2
	bra.s	\@end
\@rok:	right_macro
\@end:	move.l	d1,Abs_v(a5)
		ENDM

left_walk_macro	MACRO
	move.l	d2,d1
	ble.s	\@lok
	move.w	#FREINE,Ani(a5)
	sub.l	#FREIN_POW,d2
	bra.s	\@end
\@lok:	left_macro
	neg.l	d1
\@end:	move.l	d1,Abs_v(a5)
		ENDM

right_walk_macro	MACRO
	move.l	d2,d1
	bge.s	\@right
	move.w	#FREINE,Ani(a5)
	neg.l	d1
	add.l	#FREIN_POW,d2
	bra.s	\@end
\@right:
	right_macro
\@end:	move.l	d1,Abs_v(a5)
		ENDM

calc_abs	MACRO
	move.l	d2,d1
	bgt.s	\@done
	neg.l	d1
\@done:	move.l	d1,Abs_v(a5)
		ENDM

left_wlk_macro	MACRO
	left_macro
	calc_abs
		ENDM

right_wlk_macro	MACRO
	right_macro
	calc_abs
		ENDM
				
dec_macro	MACRO
	tst.l	d2
	beq.s	\@cas3
	bgt.s	\@cas1
	add.l	#\1,d2
	blt.s	\@cas3
\@casb:	clr.l	d2
	bra.s	\@cas3
\@cas1:	sub.l	#\1,d2
	blt.s	\@casb
\@cas3:	move.l	d2,d0
	bge.s	\@end
	neg.l	d0
\@end:	move.l	d0,Abs_v(a5)
		ENDM

dec_v_macro	MACRO
	sub.l	#STD_DEC_V/2,d2
	move.l	d2,d0
	bgt.s	\@posit
	neg.l	d0
\@posit:
	move.l	d0,Abs_v(a5)
		ENDM

inc_v_macro	MACRO
	add.l	#STD_DEC_V/2,d2
	move.l	d2,d0
	bgt.s	\@positif
	neg.l	d0
\@positif:
	move.l	d0,Abs_v(a5)
		ENDM

Dec_v_macro	MACRO
	sub.l	#STD_DEC_V,d2
	move.l	d2,d0
	bgt.s	\@posit
	neg.l	d0
\@posit
:	move.l	d0,Abs_v(a5)
		ENDM

Inc_v_macro	MACRO
	add.l	#STD_DEC_V,d2
	move.l	d2,d0
	bgt.s	\@positif
	neg.l	d0
\@positif:
	move.l	d0,Abs_v(a5)
		ENDM

DEC_v_macro	MACRO
	sub.l	#STD_DEC_V,d2
	move.l	d2,d0
	bgt.s	\@posit
	neg.l	d0
\@posit
:	move.l	d0,Abs_v(a5)
		ENDM

INC_v_macro	MACRO
	add.l	#STD_DEC_V,d2
	move.l	d2,d0
	bgt.s	\@positif
	neg.l	d0
\@positif:
	move.l	d0,Abs_v(a5)
		ENDM

boule_macro	MACRO
	tst.l	d2
	beq.s	\@cas3
	bgt.s	\@cas1
	add.l	#BOULE_DEC,d2
	blt.s	\@cas3
\@casb:	clr.l	d2
	clr.b	Boule(a5)
	bra.s	\@cas3
\@cas1:	sub.l	#BOULE_DEC,d2
	blt.s	\@casb
\@cas3:	move.l	d2,d0
	bge.s	\@end
	neg.l	d0
\@end:	move.l	d0,Abs_v(a5)
		ENDM

nokey_macro	MACRO
	dec_macro	STANDART_DEC
		ENDM

INC_boule_macro	MACRO
	add.l	#BOULE_DEC*7*1/4,d2
	blt.s	\ok
	add.l	#BOULE_DEC*7*3/4,d2
\ok:	
	calc_abs
		ENDM

DEC_boule_macro	MACRO
	sub.l	#BOULE_DEC*7/4,d2
	bgt.s	\ok
	sub.l	#BOULE_DEC*7*3/4,d2
\ok:	
	calc_abs
		ENDM

Inc_boule_macro	MACRO
	add.l	#BOULE_DEC*7/2/4,d2
	blt.s	\ok
	add.l	#BOULE_DEC*7/2*3/4,d2
\ok:	
	calc_abs
		ENDM

Dec_boule_macro	MACRO
	sub.l	#BOULE_DEC*7/2/4,d2
	bgt.s	\ok
	sub.l	#BOULE_DEC*7/2*3/4,d2
\ok:
	calc_abs
		ENDM

inc_boule_macro	MACRO
	add.l	#BOULE_DEC*7/4/4,d2
	blt.s	\ok
	add.l	#BOULE_DEC*7/4*3/4,d2
\ok:	
	calc_abs
		ENDM

dec_boule_macro	MACRO
	sub.l	#BOULE_DEC*7/4/4,d2
	bgt.s	\ok
	sub.l	#BOULE_DEC*7/4*3/4,d2
\ok:	
	calc_abs
		ENDM

		