; *********************************************************************
; 			Menu
; *********************************************************************

; Save file description
Sv_signature	equ	-4
Sv_world_name	equ	0
Sv_level_no	equ	8+1
Sv_start_x	equ	10
Sv_start_y	equ	12
Sv_life		equ	14
Sv_var_type	equ	16
Sv_end		equ	16+3
Sv_size		equ	Sv_end-Sv_signature

do_menu:
	jsr	genlib::set_LCD_MEM
	move.l	a6,a5		; A5 : save  a6
	lea	\do_menu(Pc),a6
	jmp	genlib::use_int1
	
\do_menu:
	; Restore a6
	move.l	a5,a6
	moveq	#0,d4			; Item 0
Main_menu:
	moveq	#12,d2			; D2.w = Len of the box in bytes
	moveq	#20,d1			; Y position
	moveq	#5,d3			; 5 items in menu
	lea	_comment(Pc),a0		; Title
	lea	Item_to_a0(Pc),a3	; Call back function
	moveq	#0,d0
	bsr	menu
	move.w	d0,d4			; Save new value of item
	blt	memory_error
	beq.s	Create_new_game
	subq.w	#1,d0
	beq	Menu_Load_game
	subq.w	#1,d0
	beq	Menu_option
	subq.w	#1,d0
	beq	Menu_option2
	bra	Menu_option3

Create_new_game:
	; Select the world
	move.l	#LEVEL_SIGNATURE,d7
	lea	level_search_str(pc),a0
	bsr	FileSearch
	tst.b	d1
	bne	memory_error

	move.w	d0,d5			; D5 = hd of the world

	lea	Free_buffer(a6),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+		; Save world name

	; Input file name
	lea	Input_game_str(Pc),a0
	moveq	#16,d2			; D2.w = Len of the box in bytes
	moveq	#48,d1			; Y position
	bsr	PutBox	
	move.w	d1,d2			; Y position
	moveq	#8,d3			; 8 Caracteres maximun
	moveq	#62,d1			; X
	bsr	InputStr	

	; Test NULL string...
	tst.w	d0
	bne.s	\create
		; No string => No save
		lea	Free_buffer(a6),a1
		bra.s	\write_save
\create:	
	; Create file			; A0 -> String of the save-file
	load_main_handle	d0
	jsr	filelib::createfile
	tst.w	d2
	bne	File_invalide

	move.l	a0,a4		; A4 = SYM_ENTRY of the save

	; ReAlloc Mem
	pea	(Sv_size+2).W
	move.w	tios::SYM_ENTRY.hVal(a0),-(a7)
	jsr	tios::HeapRealloc
	addq.l	#6,a7
	tst.l	d0
	beq	Memory

	; Here d0.w = Handle of the file / a4 -> SYM_ENTRY
	tios::DEREF d0,a1
\write_save
	move.w	#Sv_size,(a1)+			; Handle size-1
	move.l	#('SXSV'),(a1)+			; Signature
	move.l	a1,Save_adr(a6)			; Save adress
	move.l	Free_buffer(a6),(a1)+		; Copie du monde (nom du fichier)
	move.l	Free_buffer+4(a6),(a1)+		; " 
	clr.b	(a1)+				; NULL STRING
	clr.b	(a1)+				; Current level in save
	clr.w	Level_no(a6)			; Current level for the program
						; Save starting point	
	tios::DEREF d5,a0			; Get the adress of the world
	addq.l	#6,a0				; Skip hd'size and signature
	move.l	a0,World_adr(a6)		; Save the adress of the world
	adda.w	WORLD_TABLE(a0),a0		; A0 -> 1st Level 
	move.w	(START_X)(a0),d0
	move.w	d0,(a1)+			; Coordinates of the starting point
	move.w	d0,Start_x(a6)			; Save x position
	move.w	(START_Y)(a0),d0
	move.w	d0,(a1)+
	move.w	d0,Start_y(a6)			; Save y position

	moveq	#3,d0				; Life
	move.w	d0,(a1)+			; in save
	move.w	d0,Life(a6)			; for the program

	clr.w	(a1)+				; Null string
	move.b	#($2D),(a1)+			; a string !
	
	rts

Menu_Load_game:
	move.l	#'SXSV',d7
	lea	game_search_str(pc),a0
	bsr	FileSearch
	tst.b	d1			; Ok ?
	bne	memory_error		; Error
	tios::DEREF	d0,a0		; Get the adress of the handle d0.w
	addq.l	#(2+4),a0		; A0 -> World's string
	move.l	a0,Save_adr(a6)

	; Load data
	moveq	#0,d1
	move.b	Sv_level_no(a0),d1
	move.w	d1,Level_no(a6)			; Current level
	move.l	Sv_start_x(a0),Start_x(a6)	; Start_x & Start_y
	move.w	Sv_life(a0),Life(a6)		; Life

	; World found ?
	move.l	a0,-(a7)
	bsr	search
	move	tios::SYM_ENTRY.hVal(a0),d1	;Get handle of file in d1
	move.l	(a7)+,a0
	tst.w	d0
	beq	File_not_found
	tios::DEREF d1,a1
	addq.l	#2,a1
	move.l	(a1)+,d0
	cmp.l	#(LEVEL_SIGNATURE),d0
	beq.s	\done
		cmp.l	#(NEXT_SIGNATURE),d0
		bne	File_invalide
\done:
	move.l	a1,World_adr(a6)
	rts

; Save : Life / starting point / level
Save_game:
	move.l	a0,-(a7)
	move.l	Save_adr(a6),a0
	move.w	Life(a6),Sv_life(a0)
	move.l	Start_x(a6),Sv_start_x(a0)
	move.b	(Level_no+1)(a6),Sv_level_no(a0)
	move.l	(a7)+,a0
	rts

Menu_option:
	move.w	speed_level(a6),d0
	addq.w	#1,d0
	cmp.w	#2,d0
	bls.s	\no_reset
	clr.w	d0
\no_reset:
	move.w	d0,speed_level(a6)
	lsl.w	#2,d0
	lea	Level1(Pc,d0),a0
	move.l	(a0),Option_str+6
	bra	Main_menu

Level1:	dc.b "*   "
Level2:	dc.b "**  "
Level3:	dc.b "*** "

Menu_option2:
	moveq	#'2',d0
	eor.b	#4,Print_opt
	beq.s	\twice
	moveq	#'1',d0
\twice:	move.b	d0,Option2_str+6
	bra	Main_menu

Menu_option3:
	lea	wait_frame_dat+2(Pc),a0
	lea	Option3_str+6(Pc),a1
	lea	calcul_time_inc(Pc),a2
	moveq	#6-1,d0
	cmp.l	(a0),d0
	beq.s	\set_turbo
		move.l	d0,(a0)
		move.l	#'OFF ',(a1)
		move.w	#$5440,(a2)	;addq.w	#2,d0
		move.w	#$552D,d0	; subq.w #2,xx(a5)
		bra.s	\cont
\set_turbo:
	move.l	#3-1,(a0)
	move.l	#' ON ',(a1)
	move.w	#$5240,(a2)	;addq.w	#1,d0
	move.w	#$532D,d0	; subq.w #1,xx(a5)
\cont
	lea	Ani_dec_cpt_0(Pc),a0
	move.w	d0,(a0)
	move.w	d0,Ani_dec_cpt_1-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_2-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_3-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_4-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_5-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_6-Ani_dec_cpt_0(a0)
	move.w	d0,Ani_dec_cpt_7-Ani_dec_cpt_0(a0)
	bra	Main_menu

; Search a level
; Return :
;	d1 = 0 -> Ok
;	d0 = Handle of the selected file
;	a0 -> vat entry of the file

LevelSearch:
	move.l	#LEVEL_SIGNATURE,d7
	lea	level_search_str(pc),a0

; File 
; Input  : d7.l = FILTER
;	a0 -> Title of the box_dialog.
; Output : if d1.b=0, then d0.w = Handle and a0 -> File index of file else an error
FileSearch:
;	jsr	genlib::set_LCD_MEM
;	bsr	Clear_LCD_MEM
	moveq	#34,d1			; VPos
	moveq	#10,d2			; D2.w = Len of the box in bytes
	; Calc number of files
	move.w	#5000,d0		; Max : 5000 files :)
	move.l	a0,-(a7)
	bsr	File_no
	move.l	(a7)+,a0
	neg.w	d0
	add.w	#5000,d0
	move.w	d0,d3			; D3 = Number of files
	beq.s	Empty
		lea	File_no(Pc),a3		; DEREF function
		bsr.s	menu
		tst.w	d0
		slt.b	d1
		bsr	File_no				; Get a0
		move.w	tios::SYM_ENTRY.hVal(a0),d0	; And handle
		rts

Empty:	lea	Nofile_to_a0(Pc),a3
	bsr.s	menu
	st	d1
	rts






; Menu
; Input :
;	D1.w = Y_pos
;	D2.w = Len of the box in bytes
;	D3.w = Max item
;	d4.w = Item numero
;	A0 -> Title
;	A3 -> Function to get the string of Item no d0.w
; Out : d0.w = No of selected item or -1 if ESC
; The routine only use :
;	D0-D3 / a0 -a2
menu:
	movem.l	d1-d7/a0-a6,-(a7)

	; Prepare la boite et l'ecran titre
	bsr	PutBox

\conti:
	bsr.s	Menu_Display
	jsr	genlib::wait_a_key
	jsr	genlib::read_joypad
	btst.l	#up_key,d0
	bne.s	\no_up
		subq.w	#1,d4
\no_up:	btst.l	#down_key,d0
	bne.s	\no_down
		addq.w	#1,d4
\no_down:
	bsr.s	correct_d4
	btst.l	#ka_key,d0
	beq.s	\exit
	btst.l	#exit_key,d0
	bne.s	\conti

	moveq	#-1,d4
\exit:
	move.w	d4,d0
	movem.l	(a7)+,d1-d7/a0-a6
	rts

DISPLAY_ITEM	EQU	3
FIRST_ITEM	EQU	1
LAST_ITEM	EQU	DISPLAY_ITEM-FIRST_ITEM

; Corrige d4 pour qu'il se trouve dans l'intervalle
; In
;	d4.w = Item numero
;	d3.w = Max items
; Out:
;	d4.w = Correct item
; Destroy:
;	d4
correct_d4:
	cmp.w	d3,d4
	blt.s	\Ok1
		moveq	#0,d4
\Ok1:	tst.w	d4
	bge.s	\Ok2
		move.w	d3,d4
		subq.w	#1,d4
\Ok2:	rts


Menu_Display:
	movem.l	d0-d5/a0-a1,-(a7)
	bsr.s	Clear_zone
	moveq	#DISPLAY_ITEM-1,d5
	subq.w	#FIRST_ITEM,d4
\loop:
		bsr.s	correct_d4
		move.w	d4,d0
		jsr	(a3)			; Get string of item d0.w
		bsr	str_len
		cmp.w	#1,d5
		bne.s	\no_select
			mulu.w	#8,d0
			sub.w	#LCD_WIDTH,d0
			neg.w	d0
			lsr.w	#1,d0
			jsr	genlib::put_large_string
			bra.s	\done
\no_select:
		mulu.w	#7,d0
		sub.w	#LCD_WIDTH,d0
		neg.w	d0
		lsr.w	#1,d0
		jsr	genlib::put_medium_string
\done:		addq.w	#1,d4
		add.w	#10,d1
		dbf	d5,\loop
	movem.l	(a7)+,d0-d5/a0-a1
	rts

Clear_zone:
	movem.l	d0-d3,-(a7)
	moveq	#0,d3
	moveq	#(DISPLAY_ITEM*10-1),d0
	bsr	Fill_zone
	movem.l	(a7)+,d0-d3
	rts

; Callback functions for :
; + Empty
; + File handler
; + Main menu

; File handler DEREF
; In : d0.w / d7.l = Signature
; Out : a0 
File_no:
	movem.l	d1-d2/d4/a1-a2,-(a7)

	load_folder_list_handle	d1
	tios::DEREF	d1,a1	;a1 contains list of folders
	addq.l	#2,a1		;2 for numfolders position

	move.w	(a1)+,d4	;Get number of folders to d4
	subq.w	#1,d4
\find_in_folder:
		move.w	SYM_ENTRY.hVal(a1),d1	;Get handle of first folder to d0

		tios::DEREF	d1,a0	;Get ptr from handle
		addq.l	#2,a0
		move.w	(a0)+,d1	;Get num files in folder
		beq.s	\folder_empty	;Quit if it's zero
		subq.w	#1,d1
\file_search:
			move.w	SYM_ENTRY.hVal(a0),d2
			tios::DEREF	d2,a2	;Get ptr for first file in folder
			cmp.l	2(a2),d7
			bne.s	\ft_ignore	;If the ident is invalid, ignore this file
			subq.w	#1,d0
			blt.s	\done
\ft_ignore:
			adda.w	#SYM_ENTRY.sizeof,a0
			dbra.s	d1,\file_search
\folder_empty:
		adda.w	#SYM_ENTRY.sizeof,a1
		dbf	d4,\find_in_folder
\done:	movem.l	(a7)+,d1-d2/d4/a1-a2
	rts


; Main menu DEREF
; in  :d0
; Out :a0
Item_to_a0
	move.w	d0,-(a7)
	add.w	d0,d0
	move.w	Main_menu_data(Pc,d0.w),d0
	lea	Main_menu_data(Pc,d0.w),a0
	move.w	(a7)+,d0
	rts

Main_menu_data:
	dc.w	New_str-Main_menu_data
	dc.w	Load_str-Main_menu_data
	dc.w	Option_str-Main_menu_data
	dc.w	Option2_str-Main_menu_data
	dc.w	Option3_str-Main_menu_data

; Function which DEREF always 'empty
Nofile_to_a0:
	lea	nofile_str(PC),a0
	rts

	EVEN
