; *********************************************************************
; 			Sprite routines & table
; *********************************************************************

 include "spr_sonc.asm"
 include "spr_ring.asm"
 include "spr_star.asm"
 include "spr_shld.asm"
 include "spr_item.asm"
 include "spr_end.asm"
 include "spr_exp2.asm"
 include "spr_rock.asm"
 include "spr_spe1.asm"
 include "spr_spe2.asm"
 include "spr_spe3.asm"
 include "spr_spe4.asm"
 include "spr_spe5.asm"
 include "spr_spe6.asm"
 include "spr_plat.asm"
 include "spr_pant.asm"
 include "spr_coct.asm"
 include "spr_lapn.asm"
 include "spr_watr.asm"
 include "spr_garb.asm"
 include "spr_scrr.asm"
 include "spr_cass.asm"
 include "spr_bloc.asm"
 include "spr_bule.asm"
 include "spr_ns.asm"

 include "spr_exts.asm"

; Init a sprite and add it in the sprite buffer
; Call :
;	d0.w = X
;	d1.w = Y
;	d2.w = Type of the sprite
;	d3.w = Offset
InitSprite:
Init_sprite:
init_sprite:
	movem.l	d0-d5/a0-a5,-(a7)

	out	#$CC

	lsl.w	#4,d2		; D2 = D2 * 16

	move.l	Sprite_adr(a6),d5
	add.l	#(SIZE_SPRITE_BUFFER),d5
	move.l	Sprite_end_adr(a6),a5

	cmp.l	a5,d5
	bls.s	\too_many_sprite

	; Reset
	clr.b	Animation(a5)
	clr.b	Ani_cpt(a5)

	; Calculate SIN
;	move.l	Current_SIN(a6),d5
;	addq.l	#1,d5
;	move.l	d5,Current_SIN(a6)	

	; Save SIN
;	move.l	d5,SIN(a5)
	lea	Sprite_table(PC,d2.w),a3

	; Exec_adr = adress of the exec routine
	move.w	2(a3),d5
	beq.s	\Groupe_sprite

	lea	Sprite_table(Pc,d5.w),a0
	move.l	a0,Exec_adr(a5)

	; Size 
	move.w	4(a3),Taille(a5)
	; Delta coordinate
	move.b	6(a3),d5
	ext.w	d5
	add.w	d5,d0
	move.b	7(a3),d5
	ext.w	d5
	add.w	d5,d1
	move.w	d0,Xj(a5)
	move.w	d1,Yj(a5)

	; Offset : to clear and restore the sprite
	move.w	d3,Offset(a5)
	move.b	8(a3),Type_aff(a5)
	clr.b	Force(a5)

	; Gfx_adr ?
	move.l	12(a3),a0
	clr.w	d5
	move.b	9(a3),d5
	blt.s	\done
		bsr	deref_data
\done:	move.l	a0,Dessin(a5)

	; Animation
	lea	Anim_table(Pc),a0
	move.l	a0,Ani_adr(a5)
	move.w	10(a3),Ani(a5)

	; Special init of the sprite
	move.w	0(a3),d5
	jsr	Sprite_table(Pc,d5.w)

	add.w	Taille(a5),a5
	move.l	a5,Sprite_end_adr(a6)

\too_many_sprite:
	movem.l	(a7)+,d0-d5/a0-a5
	rts

\Groupe_sprite:
	move.w	0(a3),d5
	jsr	Sprite_table(Pc,d5.w)
	bra.s	\too_many_sprite

; Sprite table
; C'est le coeur du systeme !
; Maximun : 2^(16-4) = 2^12 = 4096 sprites
 
Sprite_table:
 ADD_SPRITE	SPR_SONIC,sonic_init,sonic_exe,Taille_sonic,0,0,PBGS_ANI,8,DEBOUT,0
 ADD_SPRITE	SPR_EXT0,ext0_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT1,ext1_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT2,ext2_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT3,ext3_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT4,ext4_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT5,ext5_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT6,ext6_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT7,ext7_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT8,ext8_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXT9,ext9_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTA,extA_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTB,extB_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTC,extC_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTD,extD_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTE,extE_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTF,extF_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA0,extra0_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA1,extra1_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA2,extra2_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA3,extra3_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA4,extra4_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA5,extra5_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA6,extra6_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_EXTRA7,extra7_init,external_exe,0,0,0,0,-1,0,0
 ADD_SPRITE	SPR_RING,ring_init,ring_exe,Taille_ring,0,0,P16X16,-1,1,0
 ADD_SPRITE	SPR_BSTAR,star_init,star_exe,Taille_star,0,0,P16X16_ANI,0,ANI_BSTAR,0
 ADD_SPRITE	SPR_STAR,star_init,star_exe,Taille_star,0,0,P16X16_ANI,0,ANI_STAR,0
 ADD_SPRITE	SPR_EXP1,star_init,star_exe,Taille_star,0,0,P16X16_ANI,0,ANI_EXP1,0
 ADD_SPRITE	SPR_EXP2,exp2_init,exp2_exe,Taille_exp2,0,0,P16X16_ANI,0,ANI_EXP1,0
 ADD_SPRITE	SPR_EXP3,exp3_init,Sprite_table,0,0,0,0,0,0,0
 ADD_SPRITE	SPR_ROCK,rock_init,rock_exe,Taille_rock,0,0,P16X16,0,15-4,0
 ADD_SPRITE	SPR_GROCK,rock_group,Sprite_table,0,0,0,0,0,0,0
 ADD_SPRITE	SPR_SHIELD,shield_init,shield_exe,Taille_shield,0,0,PBGS_ANI,6,ANI_SHIELD,0
 ADD_SPRITE	SPR_ITEM_10,item_up_init,item_up_exe,Taille_item_up,0,0,P16X16,0,0,0
 ADD_SPRITE	SPR_ITEM_EL,item_up_init,item_up_exe,Taille_item_up,0,0,P16X16,0,1,0
 ADD_SPRITE	SPR_ITEM_SD,item_up_init,item_up_exe,Taille_item_up,0,0,P16X16,0,2,0
 ADD_SPRITE	SPR_ITEM_SS,item_up_init,item_up_exe,Taille_item_up,0,0,P16X16,0,3,0
 ADD_SPRITE	SPR_ITEM_IV,item_up_init,item_up_exe,Taille_item_up,0,0,P16X16,0,4,0
 ADD_SPRITE	SPR_END,end_init,end_exe,Taille_end,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL1,special1_init,special1_exe,Taille_special1,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL2,special2_init,special2_exe,Taille_special2,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL3,special3_init,special3_exe,Taille_special3,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL4,special4_init,special4_exe,Taille_special4,0,0,PEXE,-1,0,special4_putexe
 ADD_SPRITE	SPR_PLAT_FORM1,plat_form1_init,plat_form_exe,Taille_plat_form,0,0,PBGS,10,0,0
 ADD_SPRITE	SPR_BIG_BLOC1,plat_form1_init,Big_bloc_exe,Taille_big_bloc,0,0,PBGS,3,0,0
 ADD_SPRITE	SPR_PANNEAU,panneau_init,panneau_exe,Size_panneau,0,16-40,PBGS_ANI,7,0,0
 ADD_SPRITE	SPR_RABBIT,lapin_init,lapin_exe,Size_lapin,0,0,PBGS,9,0,0
 ADD_SPRITE	SPR_COCOTE,cocote_init,cocote_exe,Size_cocote,0,-(63-16),PBGS,1,0,0
 ADD_SPRITE	SPR_MOVE_WATER,move_water_init,move_water_exe,Size_move_water,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SET_WATER,set_water_init,move_water_exe,0,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_GARBESH,garbesh_init,garbesh_exe,size_garbesh,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SEMI_GARBESH,semi_garbesh_init,semi_garbesh_exe,size_garbesh,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SCROLL_RIGHT,Scroll_right_init,Scroll_right_exe,size_scroll_right,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL5,special5_init,special5_exe,Taille_special5,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_CASSABLE,cassable_init,cassable_exe,Taille_cassable,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_SPECIAL6,special6_init,special6_exe,Taille_special6,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_ECLAT,star_init,star_exe,Taille_star,0,0,PBGS,4,0,0
 ADD_SPRITE	SPR_BULLE,bulle_init,bulle_exe,Taille_bulle,0,0,P16X16,0,12,0
 ADD_SPRITE	SPR_NS,NS_init,NS_exe,size_NS,0,0,NOTHING,0,0,0
 ADD_SPRITE	SPR_RING2,ring_init,ring2_exe,Taille_ring,0,0,P16X16,0,1,0

gestion_sprites:
	move.l	Test_adr(a6),a4
	move.l	Sprite_adr(a6),a5
	move.l	(a7),Free_buffer+4(a6)
gestion_sprites_loop:
		move.l	Exec_adr(a5),a0
		jsr	(a0)
gestion_sprites_in:
		add.w	Taille(a5),a5
gestion_sprites_destroy:
		cmp.l	Sprite_end_adr(a6),a5
		bmi.s	gestion_sprites_loop
	rts

Destruction_sprites:
	move.l	#(30000*65536+30000),d6
	move.l	Test_adr(a6),a4
	move.l	Sprite_adr(a6),a5
	bra.s	gestion_sprites_in

; a5.l -> Sprite
; Destroy a0,a1,d0 and d1
destroy_sprite:
Destroy_sprite:
DestroySprite:
	out	#$CF

	moveq	#0,d0
	move.w	Taille(a5),d0

	move.l	a5,a0		; Source
	move.l	a5,a1
	adda.l	d0,a1		; Destination

	move.l	Sprite_end_adr(a6),d1	; Get spriteADREnd
	sub.l	a1,d1		; Get number of bytes to move
	sub.l  d0,Sprite_end_adr(a6)	; Correct the new value of SriteADREnd

	tst.w	d1
	beq.s	\end
	lsr.w	#2,d1		; Get number of double words to move
				; It is on one word
\DelBoucle:
		move.l	(a1)+,(a0)+
		dbf.s	d1,\DelBoucle
\end:	addq.l	#4,a7
	bra.s	gestion_sprites_destroy
 