; *******************************************
; 		Sprites definitions :
; *******************************************

ADD_CAR		MACRO
\1		set	Sprite_car
Sprite_car	set	Sprite_car+\2
		ENDM

NEW_SPRITE	MACRO
Sprite_car	set	Reset_sprite_car
		ENDM

TAILLE_SPRITE	MACRO
\1		set	Sprite_car
		ENDM

SIZE_SPRITE	MACRO
\1		set	Sprite_car
		ENDM

Sprite_car	set	0

; Sprite base format
	ADD_CAR	Exec_adr,4	; Adress of the exec routine of the sprite
	ADD_CAR	Gfx_adr,4	; Adress of the image_table
	ADD_CAR	Ani_adr,4	; Adress of the anim table
	ADD_CAR	SIN,4		; S.I.N. : Sprite Identifying Number
	ADD_CAR	Size,2		; Size of the sprite
	ADD_CAR	Offset,2	; offset for ennemis
	ADD_CAR	Drawing,1	; Way of drawing
	ADD_CAR	Force,1		; Feedback
	ADD_CAR	Ani,2		; Current animation
	ADD_CAR	Ani_cpt,1	; Sub-data for 'Ani'
	ADD_CAR	Animation,1	; Sub-data for 'Ani'
	ADD_CAR	Xj,2		; X position for drawing routine
	ADD_CAR	Yj,2		; Y position for drawing routine

Reset_sprite_car	set Sprite_car

; Francophone :)
Dessin		EQU	Gfx_adr
Taille		EQU	Size
Type_aff	EQU	Drawing

; Sprite_table data and macro
Spr_table_compteur		set	0
Spr_table_compteur2		set	0
finish_sprite_table_compteur	set	0
ADD_SPRITE	MACRO
	dc.w	\2-Sprite_table	; Init
	dc.w	\3-Sprite_table	; Code
	dc.w	\4	; Taille
	dc.b	\5	; Dx
	dc.b	\6	; Dy
	dc.b	\7	; Type_aff
	dc.b	\8	; Force
	dc.w	\9	; Ani
	dc.l	\10	; Dessin de base
\1		set	Spr_table_compteur
Spr_table_compteur	set	Spr_table_compteur+1
		ENDM

INC_SPRITE	MACRO
\1		set	Spr_table_compteur2
Spr_table_compteur2	set	Spr_table_compteur2+1
	ENDM

ADD_GROUPE	MACRO
	dc.w	\2-Sprite_table	; Init
	dc.w	0	; Code
	dc.w	0	; Taille
	dc.b	0	; Dx
	dc.b	0	; Dy
	dc.b	0	; Type_aff
	dc.b	0	; Force
	dc.w	0	; Ani
	dc.l	0	; Dessin de base
\1		set	Spr_table_compteur
Spr_table_compteur	set	Spr_table_compteur+1
		ENDM

ADD_NOTHING	MACRO
	dc.w	nothing_init-Sprite_table	; Init
	dc.w	0	; Code
	dc.w	0	; Taille
	dc.b	0	; Dx
	dc.b	0	; Dy
	dc.b	0	; Type_aff
	dc.b	0	; Force
	dc.w	0	; Ani
	dc.l	0	; Dessin de base
Spr_table_compteur	set	Spr_table_compteur+1
		ENDM

END_SPRITE_TABLE	MACRO
	ifne	Spr_table_compteur-(16+8)
	error there are not 16 + 8 sprites in the sprite table !
	endif
			ENDM

FINISH_SPRITE_TABLE	MACRO
	ifne	Spr_table_compteur-(16+8)
	ADD_NOTHING
finish_sprite_table_compteur	set	finish_sprite_table_compteur+1
	ifeq	finish_sprite_table_compteur-(16+8)
	error	Too many sprites in the sprite table !
	endif
	FINISH_SPRITE_TABLE
	endif
			ENDM
; Type_aff value
NOTHING		EQU	0
H_FLIP		EQU	2
V_FLIP		EQU	4
P16X16_ANI	EQU	8
PBGS_ANI	EQU	16
P16X16		EQU	24
PBGS		EQU	32
PEXE		EQU	40

Type_aff_H	EQU	1
Type_aff_V	EQU	2




; *******************************************
; 		Level description :
; *******************************************

level_variable	set	0

LEVEL_SIGNATURE	EQU	'SXWD'
NEXT_SIGNATURE	EQU	'SXNX'

ADD_CLVL	MACRO
\1		set	level_variable
level_variable	set	level_variable+\2
		ENDM

 ADD_CLVL	GFX1_FILENAME,9			; Nom fichier graph 1
 ADD_CLVL	GFX1_TYPE,1			; Type effet special graph 1
 ADD_CLVL	GFX2_FILENAME,9			; Nom fichier graph 2
 ADD_CLVL	GFX2_TYPE,1			; Type effet special graph 2
 ADD_CLVL	SPRITE_FILENAME,9		; Nom fichier sprite
 ADD_CLVL	FLAG_EXTRA,1			; Mode word / byte
 ADD_CLVL	LEVEL_NAME,20			; Nom du niveau
 ADD_CLVL	MX1,1				; Nombre de sous niveau x
 ADD_CLVL	MY1,1				; Nombre de sous niveau y
 ADD_CLVL	SX1,1				; Taille x d'un sous niveau (2^sx1)
 ADD_CLVL	SY1,1				; Taille y d'un sous-niveau
 ADD_CLVL	SX2,1				; Taille arriere plan x
 ADD_CLVL	SY2,1				; Taille arriere plan y
 ADD_CLVL	START_X,2			; Debut
 ADD_CLVL	START_Y,2	
 ADD_CLVL	DATA,0

; *******************************************
; 		World description :
; *******************************************

WORLD_NBR	EQU	0
WORLD_NEXT	EQU	2
WORLD_TABLE	EQU	12

	