; *********************************************************************
; 			Routines internes
;		C'est un peu le foutoir :(
; *********************************************************************


; Efface la donne de la matrice graph/test
; Ces routines ne sont pas hyper-optimisees mais c'est vraiment pas grave !
; IN:  d0 = x, d1 = y
; OUT: Data cleared
clear_data:
	movem.l	d0-d1/a0,-(a7)
	bsr.s	clear_internal
	move.l	Clear_level_adr(a6),a0
	move.w	d0,d1
	lsr.w	#3,d1
	and.w	#7,d0
	bset.b	d0,0(a0,d1.w)
	movem.l	(a7)+,d0-d1/a0
	rts
	
clear_internal:
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d1,d0
	move.l	Graph_adr(a6),a0
	tst.b	FlagWB(a6)
	beq.s	\byte_model
		move.w	d0,d1
		add.w	d1,d1
		clr.w	0(a0,d1.w)
		bra.s	\done
\byte_model:
		clr.b	0(a0,d0.w)
\done:
	move.l	Test_adr(a6),a0
	clr.b	0(a0,d0.w)
	rts
	
; IN:  d0 = x, d1 = y
; OUT: Data cleared in the sub-level but not add in clear-buffer
clear_in_data:
	movem.l	d0-d1/a0,-(a7)
	bsr.s	clear_internal
	movem.l	(a7)+,d0-d1/a0
	rts
	

; Determine la direction par le FLAG OBJ_DIRECTION
; Fait plusieurs tours successifs autour de la position initale
; pour prendre le plus proche OBJ_DIRECTION
; In : D3.w = Offset / a4 -> Test_table
; Out : d0.w =Dx / D1.w =Dy
calculate_direction:
	movem.l	d2-d7/a0-a2,-(a7)
	; Save orignal len
	swap	d7
	; Set direction table
	move.w	Len_x(a6),d0
	move.w	d0,-(a7)	; Dy
	move.w	#1,-(a7)	; Dx
	neg.w	d0		
	move.w	d0,-(a7)	; -Dy
	move.w	#-1,-(a7)	; -Dx
	move.l	a7,a1		; A1 -> Direction table

	moveq	#2,d5		; Set R (=2*Rayon_carre+1 -1 pour dbf !)
	lea	0(a4,d3.w),a0	; Origine de la case
	move.w	Len_x(a6),d6
	addq.w	#1,d6		; Pour remonter d'une case en haut a gauche

	move.w	#2,d7		; On fait au maximun 3 tours successifs (et pas de moveq !!)
\loop1:		; Calc Offset
		suba.w	d6,a0		; On retourne en haut a gauche
		moveq	#3,d1		; Table de direction a 4 elements
\loop15:		move.w	(a1)+,d0	; Lit la direction courante
			; Calc Tmp
			move.w	d5,d4	; On avance de 3, 5 ou 7 cases
\loop2:				cmp.b	#OBJ_DIRECTION/4,(a0)	; OBJ_DIRECTION ?
				beq.s	\dir_found
				tst.w	d4
				beq.s	\last
					suba.w	d0,a0		; Next
\last:				dbf	d4,\loop2
			dbf	d1,\loop15
		subq.l	#8,a1		; Reset Direction Table
		addq.l	#2,d5		; Inc le rayon (3, 5 ou 7)
		dbf	d7,\loop1
	; Rien n'a ete trouve : on retourne (0,0)
	clr.w	d0
	clr.w	d1
\return:
	addq.l	#8,a7
	movem.l	(a7)+,d2-d7/a0-a2
	rts
; On a trouve la direction : en a0
\dir_found:
	; Retrouve d7
	swap	d7

	; Calcule la direction originale...
	; On a la position relative par rapport au debut...
	suba.l	a4,a0
	; Calc Dy :
	move.l	a0,d1
	move.w	d3,d2
	lsr.w	d7,d1
	lsr.w	d7,d2
	sub.w	d2,d1
	; Calc Dx
	move.l	a0,d0
	move.w	Mask_x(a6),d2
	and.w	d2,d0
	and.w	d2,d3
	sub.w	d3,d0
	bra.s	\return

; Efface l'ecran LCD_MEM
; In :
;	nothing
; Out :
;	nothing
; Destroy :
;	nothing
Clear_LCD_MEM:
	ifeq	OS
	movem.l	d0/a0,-(a7)
	lea	LCD_MEM,a0
	move.w	#960-1,d0
\loop:		clr.l	(a0)+
		dbf	d0,\loop
	movem.l	(a7)+,d0/a0
	rts
	endif
	ifne	OS
	jmp	flib::zap_screen
	endif
	
; Initalise les anneaux apres etre touche
; In/Out : nothing
; Destroy : d0-d5/a0
Init_rings:
	move.w	Ring(a6),d5
	beq.s	\Retour
	cmp.w	#9*8-1,d5
	bls.s	\ok
		moveq	#9*8-1,d5
\ok:	lsr.w	#3,d5		; D5 / 8
	lea	init_rings_table(Pc),a0
	move.w	Xj(a5),d0	; Original position X
	move.w	Yj(a5),d1	; Original position Y
	move.w	#SPR_RING,d2	; Type of sprite
	clr.w	d3		; Humm... Maybe useless
\loop:
		move.w	(a0)+,d4
		bsr	Init_sprite
		dbf	d5,\loop
\Retour:
	clr.w	Ring(a6)
	st.b	Refresh_window(a6)
	move.w	#100,Ring_to_life(a6)	; Reset Life counter
	rts
	
init_rings_table:
	dc.w	0,-1,1,2,-2,-3,3,4,-4

; Gere le scrolling
; In/Out : Nothing
; Destroy:
;	d0-d5/a0
gere_scrolling:
	move.l	key(a6),d4	; d4 -> key(s)

	move.l	Sprite_adr(a6),a0	; Main character IS the 1st sprite
	move.w	X(a0),d0		; Pas tres beau
	move.w	Y(a0),d1		; Non, vraiment pas...
	add.w	Vy(a0),d1	; Correction verticale

	move.w	Scroll_ax(a6),d2
	move.w	Scroll_ay(a6),d3

	; Test si on doit decaler le scrolling vers la gauche ou vers la droite.
	btst.l	#right_key,d4
	bne.s	\nor
		cmp.w	#MAX_SCROLLX,d2
		bgt.s	\endx
			addq.w	#3,d2
			bra.s	\endx
\nor:	
	btst.l	#left_key,d4
	bne.s	\nol
		cmp.w	#-MAX_SCROLLX,d2
		blt.s	\nol
			subq.w	#3,d2
\nol:
\endx:

	; Sauve la nouvelle valeur du decalage.
	move.w	d2,Scroll_ax(a6)	; Save
	add.w	d2,d0			; Correct

	; Meme chose pout haut et bas mais avec un timer.
	move.w	Scroll_cpt(a6),d2
	btst.l	#up_key,d4
	bne.s	\nou
		addq.w	#1,d2
		cmp.w	#MAX_WAIT_LOOK,d2
		bcs.s	\nothing
			cmp.w	#-MAX_SCROLLY,d3
			ble.s	\nothing
				subq.w	#3,d3
				bra.s	\nothing
\nou:	btst.l	#down_key,d4
	bne.s	\nod
		addq.w	#1,d2
		cmp.w	#MAX_WAIT_LOOK,d2
		bcs.s	\nothing
			cmp.w	#MAX_SCROLLY,d3
			bge.s	\nothing
				addq.w	#3,d3
				bra.s	\nothing
\nod:	; Si on n'appuie ni sur haut, ni sur bas, on revient a sa position normale (0)
	clr.w	d2
	tst.w	d3
	beq.s	\nothing
		bgt.s	\dec
			addq.w	#6,d3
\dec:		subq.w	#3,d3

\nothing:

	move.w	d2,Scroll_cpt(a6)
	move.w	d3,Scroll_ay(a6)
	add.w	d3,d1
	
	; On calcule les coordonnes relatives de l'ecran par rapport au personnage
	sub.w	Center_x(a6),d0
	sub.w	Center_y(a6),d1
	
	move.l	Plan_A_adr(a6),a0

	; Verification que ca appartient bien a xmin, xmax, ymin, ymax
	move.w	xmin(a6),d2
	cmp.w	d2,d0
	ble.s	\esc
		move.w	xmax(a6),d2
		cmp.w	d2,d0
		bge.s	\esc
			move.w	d0,d2
\esc:
;	tst.b	Alignement(a6)
;	beq.s	\no
;		and.w	#$FFF0,d2
;\no:
	move.w	d2,PLANE_XS(a0)

	move.w	ymin(a6),d2
	cmp.w	d2,d1
	ble.s	\esc2
		move.w	ymax(a6),d2
		cmp.w	d2,d1
		bge.s	\esc2
			move.w	d1,d2
\esc2:	move.w	d2,PLANE_YS(a0)

	tst.b	Calc_B(a6)		; If special_effect
	beq.s	\no_calc		; Do not calculate the coordinate !

		move.l	Plan_B_adr(a6),a1
		move.l	Level_adr(a6),a2

		move.w	PLANE_XS(a0),d0
		move.b	d7,d1
		sub.b	SX2(a2),d1
		lsr.w	d1,d0
		move.w	d0,PLANE_XS(a1)
	
		move.w	PLANE_YS(a0),d0
		move.b	Diff_y(a6),d1
		lsr.w	d1,d0
		move.w	d0,PLANE_YS(a1)
\no_calc:
	rts



; Random number between (0...D0-1).
; In :
;	D0.w = Max
; Out :
;	d0.w = Random value
; Destroy:
;	Nothing
; Note: original routine made by David E.
random:
	ifeq	OS
	move.l  d1,-(a7)		; saves d1
	move.w  rand_seed(a6),d1	; d1 = rand_seed
	mulu.w  #31421,d1		; rand_seed * 31421
	add.w   #6927,d1		; + 6927
	mulu.w  d1,d0			; * rand _ max
	move.w  d1,rand_seed(a6)	; new rand_seed = d1
	swap    d0			; swap
	move.l  (a7)+,d1		; restores d1
	rts
	endif
	ifne	OS
	jmp	flib::random
	endif


; Alloue de la place.
; le nombre d'octets a allouer est dans d0.l
; S'il n'y a pas assez de place, il quitte
; sur une erreur de memoire
; Sauvegarde l'handle grace a genlib::push_hd
; Et verouille l'handle (Ti-89 / Ti-92p)
; Entree:
;	D0.l = Octets a allouer
; Retourne:
;	d0.w =  Handle
;	A0.l -> Buffer
; Detruit :
;	d0-d2/a0-a1
Alloc:
	move.l	d0,-(a7)
	jsr	tios::HeapAlloc
	addq.l	#4,a7
	tst.w	d0
	beq.s	Memory
	bsr.s	push_hd
	move.w	d0,d1
	tios::DEREF	d1,a0
	rts

; Sauvegarde des handle et verouillage de ceux-ci.
; d1.w = Handle
push_hd1:
	move.w	d1,d0
; d0.w = Handle
push_hd:
	jmp	genlib::push_hd

; Libere l'handle d0.w
Free:
	move.w	d0,-(a7)
	jsr	tios::HeapFree
	addq.w	#2,a7
	rts

; Error routines
; Liste des routines gerant les erreurs.
Overflow:
;	move.w	#830,d0			; Overflow
	lea	overflow_str(Pc),a0
	bra.s	Memory_intern	
Internal:
;	moveq	#40,d0			; Argument error
	lea	internal_str(Pc),a0
	bra.s	Memory_intern
Memory:
;	move.w	#670,d0
	lea	memory_str(Pc),a0
Memory_intern:
	jsr	genlib::set_LCD_MEM
;	move.l	a6,-(a7)
;	move.w	d0,-(a7)
;	lea	tios::ERD_dialog,a6
;	jsr	genlib::use_int1	; Woah ! Une boite !
;	addq.l	#2,a7			; Print Error : Memory
;	move.l	(a7)+,a6
;	bra	memory_error
	bsr	Print
	jsr	genlib::wait_a_key	; Wait for a key ...
	bra	memory_error		; Quit the program

; Display 'File %s not found'
; In :
;	a0 -> String
; Out:
;	no return !
; Destroy :
;	/!/
File_not_found:
        move.l	a0,-(a7)		; Push string
	pea	file_not_found_str(pc)	; Push format string
F_disp:	lea	Free_buffer(a6),a4	; A4 -> string buffer
	pea	(a4)			; Push buffer address
	bsr.s	sprintf			; Write string into buffer
;	jsr	genlib::set_LCD_MEM	; Set the auto-int to the LCD_MEM
;	pea	(a4)			;
;	jsr	tios::ST_showHelp	; Show the string
;	lea	(4+4+4+4)(a7),a7	; Restore the stack pointer
;	jsr	genlib::wait_a_key	; Wait for a key ...
;	bra	memory_error		; Quit the program
	move.l	a4,a0
	bra.s	Memory_intern
	
; Display 'File invalide %s'
; In :
;	a0 -> String
; Out:
;	no return !
; Destroy :
;	/!/
File_invalide:
        move.l	a0,-(a7)		; Push string
	pea	file_invalide_str(pc)	; Push format string
	bra.s	F_disp

; Fait appel a la routine standarte sprintf
; Arguments classiques
sprintf:
	jmp	tios::sprintf

; Recherche un fichier.
; Input :
;	A0 -> Nom du fichier
; Out:
;	d0 = 0 => Error
;	A0 -> Structure Sym du fichier
; Destroy :
;	d1 / d0 / a0
search:
	moveq	#1,d1
	jmp	filelib::search

; Search and extract graph-file (->a0)
; destroy : d0-d4/a0-a4
; Out : a0 -> Graph_data
search_graph_file:
	move.l	a0,-(a7)		; Save a0 fot File_invalid and file_not_found routines
	bsr.s	search
	move	SYM_ENTRY.hVal(a0),d1	;Get handle of file in d1
	move.l	(a7)+,a0
	tst.w	d0			; Test error ?
	beq	File_not_found
	tios::DEREF	d1,a1		; A1 -> string
	addq.l	#2,a1			; Skip the size of the string
	move.l	(a1)+,d0		; Load signature
	cmp.l	#('SX16'),d0		; Ok ?
	bne.s	File_invalide
	move.l	a1,a0			; A0 -> Archive
	suba.l	a1,a1			; A1 = 0

; Input : a0 -> Archive data
;	  a1 -> Where to extract (Shnklib format !)
; Output : a0 -> Archive and d2 may be the handle
; Destroy d0-d2 / a0
do_shk:
	; Open archive
	jsr	shrnklib::OpenArchive
	tst.w	d0
	beq	Memory

	; Extract 1st archive
	moveq	#0,d1	; 1st archive
	move.l	a1,a0	
	jsr	shrnklib::Extract
	cmp.l	a0,d1	; D1 still null !
	beq	Memory	; Oublie mmoire dans certain cas !!!

	; Close archive
	jsr	shrnklib::CloseArchive
	cmp.l	a1,d1	; A1 = 0 so there is a new handle !
	bne.s	\no_do
		move.w	d2,d0
		bsr	push_hd
		tios::DEREF	d2,a0	; because TiOs may change memory !
\no_do:	rts
	
; Search the file 'smadata'
; If not found, exits.
;In/Out: nothing
; Destroy: a0-a1/d0-d2
search_rom:
	lea	rom_str(Pc),a0
	move.l	a0,-(a7)		; Save a0 fot File_invalid and file_not_found routines
	bsr.s	search
	move	SYM_ENTRY.hVal(a0),d1	;Get handle of file in d1
	move.l	(a7)+,a0
	tst.w	d0			; Test error ?
	beq	File_not_found
	tios::DEREF	d1,a1		; A1 -> string
	addq.l	#2,a1			; Skip the size of the string
	move.l	(a1)+,d0		; Load signature
	cmp.l	#('SXRM'),d0		; Ok ?
	bne	File_invalide
	move.l	a1,Rom_adr(a6)
	rts
rom_str:	dc.b	"smadata",0

; Deref an data number to its adress
; In:
;	d5.w = Data number
; Out:
;	If d5<> 0 => a0.l -> Corresponding data
;	else an error
; Destroy:
;	d5/a0
deref_data:
	move.l	Rom_adr(a6),a0
	add.w	d5,d5
	move.w	0(a0,d5.w),d5
	lea	0(a0,d5.w),a0
	rts
	
; Put the number d2.l at coordinates ( d3.w = X, d4.w = Y) with (d1).w digits
; Destroy : no registers
put_number:
Putnumber:
PutNumber:
Put_number:
	movem.l d0-d2/a0-a1,-(a7)

	lea	(Free_buffer+100)(a6),a0	; Load tempory storage string adress
	clr.b	(a0)				; Null string !
\Rep1:
		divu	#10,d2		; d2 / 10
		swap	d2		; Work on the rest
		addi.b	#'0',d2		; Add 48 to the rest of the division
		move.b	d2,-(a0)	; Save the rest
		subq.w	#1,d1		
		beq.s	\CSDone		; to avoid a crash if the number has too many digits
		clr.w	d2		; Clear the rest
		swap	d2		; New number D2.l = Int(D3.l / 10)
		bne.s	\Rep1		; No need of 'tst' because 'swap' does it

	tst.w  d1
	beq.s	\CSDone	
		subq.w	#1,d1			; For dbf
\Rep2:			move.b #'0',-(a0)	; Complete par des 0
			dbra.s	d1,\Rep2
\CSDone:
	move.w	d3,d0
	move.l	d4,d1
	move.l	genlib::window,a1
	jsr	genlib::put_large_string
	movem.l (a7)+,d0-d2/a0-a1
	rts



; Put a string on the screen
; In:
;	a0 -> String
;	d0.w = x
;	d1.w = y
; Out :
;	d2.l = 4
; Destroy:
;	d2
Display_string:
	moveq	#4,d2
	
; Put a string on the screen
; In:
;	a0 -> String
;	d0.w = x
;	d1.w = y
;	d2.w = font
; Out :
;	nothing
; Destroy:
;	nothing
PutString:
Put_string:
put_string:
	movem.l	d0-d2/a0-a1,-(a7)
	move.w	d2,-(a7)
	move.l	a0,-(a7)
	move.w	d1,-(a7)
	move.w	d0,-(a7)
	jsr	tios::DrawStrXY
	lea     10(a7),a7
	movem.l	(a7)+,d0-d2/a0-a1
	rts

; Affiche les donnes sur window
; et le recopie sur le DScreen courant
print_data:
	tst.b	Refresh_window(a6)
	beq.s	\quit

		clr.b	Refresh_window(a6)
		moveq	#0,d2

		moveq	#0,d3	; X
		moveq	#0,d4	; Y
		moveq	#1,d1	; 1 chiffre
		move.w	minute(a6),d2
		bsr	put_number

		moveq	#(16),d3	; X
		moveq	#(2),d1		; 2 chiffres
		move.w	seconde(a6),d2
		bsr	put_number

		moveq	#10,d3	; X
		moveq	#10,d4	; Y
		moveq	#3,d1	; 3 chiffres
		move.w	Ring(a6),d2
		bsr	put_number

		moveq	#20,d4	; Y
		moveq	#2,d1	; 2 chiffres
		move.w	Life(a6),d2
		bsr	put_number
\quit:	
	ifne	DEBUG
	moveq	#100,d3
	moveq	#0,d4
	moveq	#4,d1
	moveq	#0,d2
	move.w	d6,d2
	bsr	put_number

	move.w	#100+8*4,d3
	move.l	d6,d2
	clr.w	d2
	swap	d2
	bsr	put_number

	move.l	Sprite_adr(a6),a1
	moveq	#2,d1
	moveq	#100,d3
	moveq	#10,d4
	move.w	Abs_v(a1),d2
	bsr	put_number

	moveq	#120,d3
	move.w	Action(a1),d2
	bsr	put_number

	move.w	#150,d3
	move.w	Diag(a1),d2
	bsr	put_number

	move.l	Sprite_end_adr(a6),d2
	sub.l	Sprite_adr(a6),d2
	moveq	#100,d3
	moveq	#20,d4
	moveq	#5,d1
	bsr	put_number
	
	moveq	#2,d1
	move.w	#150,d3
	move.w	Ani(a1),d2
	bsr	put_number

	jmp	genlib::copy_window
	endif

	ifeq	DEBUG
	; Recopie la fentre Window sur l'ecran DScreen courant
	tst.b	All_window(a6)
	beq.s	\no
		jmp	genlib::copy_window
\no:
	; Rcrit une partie de copy_window pour aller plus vite !
	move.l	genlib::window,a0
	move.l	Current_dscreen(a6),a1
	lea	SCREEN_SIZE(a1),a2
	moveq	#(30-4),d2
	moveq	#30-1,d0
\loop:
		move.l	(a0)+,d1
		or.l	d1,(a1)+
		or.l	d1,(a2)+
		add.l	d2,a0
		add.l	d2,a1
		add.l	d2,a2
		dbf.s	d0,\loop
	rts
	endif

; Reaffiche completement la fenetre des entrees/sorties
; Efface au preliminaire cet ecran
draw_window:
	jsr	genlib::clear_window
	
	move.l	genlib::window,a1
	lea	genlib::put_large_string,a2

	moveq	#4,d2
	moveq	#0,d0

	moveq	#0,d1
	lea	time_str(Pc),a0
	jsr	(a2)
	
	moveq	#10,d1
	lea	ring_str(Pc),a0
	jsr	(a2)

	moveq	#20,d1
	lea	life_str(Pc),a0
	jmp	(a2)


; Fait avancer le temps de 1
; Attention : prevu pour tourner a 15 Hz !
; In :
;	nothing
; Out :
;	nothing
; Destroy:
;	d0-d1
calcul_time:
	move.w	centieme(a6),d0
calcul_time_inc:
	addq.w	#2,d0
	cmp.w	#30,d0
	bcs.s	\no_inc
		clr.w	d0
		move.w	seconde(a6),d1
		addq.w	#1,d1
		cmp.w	#60,d1
		bcs.s	\no_inc2
			clr.w	d1
			addq.w	#1,minute(a6)
			cmp.w	#10,minute(a6)
			bcs.s	\no_inc2
				move.b	#TIME_OVER,Exit(a6)		; Time over !
				subq.w	#1,Life(a6)
\no_inc2:
		move.w	d1,seconde(a6)
		st.b	Refresh_window(a6)
\no_inc:
	move.w	d0,centieme(a6)
	rts

; Affiche une chaine de caractere a l'endroit courant sur l'ecran
; Scrolle si necessaire.
; Input : a0 -> String
Print:
print:
	movem.l	d0-d2/a1,-(a7)
	move.w	Current_y(a6),d1
	moveq	#4,d2
	add.w	#10,d1
	cmp.w	#LCD_HEIGHT-12,d1
	bls.s	\ok
		move.l	#LCD_MEM,a1
		move.w	#960-30*10/4-1,d0
\Loop:			move.l	30*10(a1),(a1)+
			dbra	d0,\Loop
		move.w	#LCD_HEIGHT-12-4,d1
		bra.s	\print
\ok:	move.w	d1,Current_y(a6)
\print:
	moveq	#0,d0
	bsr	put_string
	movem.l	(a7)+,d0-d2/a1
	rts



; Get a key from the key buffer
; In :
;	nothing
; Out :
;	d0.w = Key code
; Destroy :
;	d0
	ifne	OS
GetKey	jmp	flib::idle_loop
	endif

	ifeq	OS
GetKey:
	movem.l	d1-d2/a0-a1,-(a7)
	clr.w	-(a7)
	clr.l	-(a7)
	jsr	tios::GKeyIn
	addq.l	#6,a7
	movem.l	(a7)+,d1-d2/a0-a1
	rts
	endif


; Input a string
; In :
;	d1.w = x
;	d2.w = y
;	d3.w = maxchar
; Out:
;	d0.w = string lenght
;	a0.l = adress of the string
; Destroy :
;	d0/a0
	ifne OS
InputStr	jmp	smalib@0002
	endif

	ifeq	OS
InputStr:
	movem.l	d1-d4/a1,-(a7)

	movem.l	d1-d2,-(a7)	; Save x-y

	move.b	#1,tios::MaxHandles+$24+$11	;ALPHA LOCK

	lea	Free_buffer+200(a6),a0		; a0 -> String

	move.l	a0,a1				; a1 -> Current char
	clr.w	d4				; 0 char

\loop:
	move.b	#' ',(a1)			; Space
	clr.b	1(a1)				; Null string
	movem.l	(a7),d0-d1			; Read x-y
	bsr	Display_string
	bsr.s	GetKey
	cmp.w	#13,d0		;Enter ?
	beq.s	\Enter
	cmp.w	#257,d0		;Clear ?
	beq.s	\Del
	cmp.w	#264,d0		;ESC ?
	beq.s	\Esc
	cmp.w	#255,d0		;Charactre invalide ?
	bhi.s	\loop
	cmp.w	d3,d4		;Maxchar ?
	beq.s	\loop
	move.b	d0,(a1)+
	addq.w	#1,d4
	bra.s	\loop

\Del:
	tst.w	d4
	beq.s	\loop
	subq.w	#1,d4
	clr.b	-(a1)
	bra.s	\loop

\Esc:
	clr.w	d4		; No char
	clr.b	(a0)		; Null string

\Enter:
	clr.b	(a1)		; Null string
	move.w	d4,d0
	addq.l	#8,a7		; Skip x.l / y.l
	movem.l (a7)+,d1-d4/a1
	rts
	endif

; Print a box
; In :
;	a0 -> String
;	d1.w = Vertical position
;	d2.w = Len in bytes
; Out:
;	d1.w = Vpos + 16 (-> Position in sub-area)
;	a1.l -> LCD_MEM
; Destroy:
;	d0
PutBox:
	move.l	d3,-(a7)

	lea	LCD_MEM,a1

	; Display Background in black
	moveq	#-1,d3				; D3 = Background
	addq.w	#2,d2				; D2 = Len in bytes
	moveq	#(DISPLAY_ITEM*10+5+10+3),d0	; D0 = Height
	bsr.s	Fill_zone

	; Put title
	addq.w	#3,d1
	bsr.s	str_len
	lsl.w	#3,d0
	sub.w	#LCD_WIDTH,d0
	neg.w	d0
	lsr.w	#1,d0
	jsr	genlib::put_large_string	; Put string

	; Print sub-area
	add.w	#10+3,d1
	subq.w	#2,d2				; Restore d2
	moveq	#(DISPLAY_ITEM*10-1),d0		; d0 = Height
	move.b	#%10001000,d3
	bsr.s	Fill_zone

	move.l	(a7)+,d3
	rts

; Remplit une zone avec un motif
; In : 
;	D0.w = Hauteur V
;	d1.w = Position V
;	d2.w = Length in bytes
;	d3.b = Ce qui faut remplir
;	a1.l = LCD_MEM
; Out:
;	nothing
; Destroy:
;	nothing
Fill_zone:
	movem.l	d0-d4/a2,-(a7)
	move.w	#LCD_LINE_BYTES,d4
	sub.w	d2,d4
	lsr.w	#1,d4
	mulu.w	#30,d1
	add.w	d1,d4
	move.l	a1,a2
	adda.w	d4,a2
\ly:		move.w	d2,d1
		subq.w	#1,d1
\lx:			move.b	d3,(a2)+
			dbf	d1,\lx
		adda.w	#30,a2
		suba.w	d2,a2
		dbf	d0,\ly
	movem.l	(a7)+,d0-d4/a2
	rts

; Calcule la longeur de la chaine -> A0 dans d0.l
; In
;	a0 -> Chaine
; Out :
;	d0.l = Lenght
; Destroy
;	d0
str_len:
	move.l	a0,d0
	move.l	a0,-(a7)
\cont:		tst.b	(a0)+
		bne.s	\cont
	sub.l	d0,a0
	move.l	a0,d0
	subq.l	#1,d0
	move.l	(a7)+,a0
	rts

; Affiche l'image No d1.w 
put_image:
	; Dereference les donnees compresses
	moveq	#12,d5
	bsr	deref_data
	tst.w	d5
	beq	\return

	; Selectionne le bon DScreen
	move.l	Screen_1(a6),d0
	jsr	genlib::set_dscreen_function
	jsr	genlib::cls
	jsr	genlib::set_dscreen_int
	move.l	Screen_2(a6),d0
	jsr	genlib::set_dscreen_function

	; Ouvre l'archive
	jsr	shrnklib::OpenArchive
	move.w	d0,d6
	beq	\return

	; Extrait les donnes
	suba.l	a0,a0		
	jsr	shrnklib::Extract
	cmp.l	d1,a0
	beq	\return_free

	; Affiche l'image zoome
	move.l	a0,a1
	moveq	#0,d0
	moveq	#0,d1
	move.l	#65536,d4
	move.l	#65536,d5
	tst.b	Calc(a6)
	bne.s	\d
		move.l	#(65536*240/160),d4
		move.l	#(65536*100/128),d5
\d:	jsr	genlib::cls
	jsr	genlib::put_big_sprite_zoom

	; Fixe l'ecran et attend une touche
	move.l	Screen_2(a6),d0
	jsr	genlib::set_dscreen_int
	jsr	genlib::wait_a_key

	; Libere la memoire
	move.w	d2,d0
	bsr	Free
\return_free:
	move.w	d6,d0
	bsr	Free
\return:
	rts
	
	