; *******************************************
; 		World routines :
; *******************************************

exec_world:
\first:
	; Exec the level
	move.l	World_adr(a6),a5	; A5 -> Adress of the world
	moveq	#0,d0			; For full 64ko access
	move.w	Level_no(a6),d0		; No of the currentlevel
	add.w	d0,d0			; An offset <=> 1 word
	move.w	WORLD_TABLE(a5,d0.w),d0	; get the offset
	add.l	d0,a5			; A5 -> Level
	move.l	Start_x(a6),d5		; Coordinates of the starting point : (0,0)
	jsr	genlib::set_LCD_MEM	; To see the information when loading
	bsr	exec_level		; Exec the level

	; Case exit
	move.b	Exit(a6),d1		; In function of exit, we will :
	
	cmp.b	#QUIT,d1		; Quit !!!
	beq	memory_error
	
	cmp.b	#TIME_OVER,d1		; Time-Over
	bne.s	\no_time_over
		lea	time_over_str(Pc),a2
		bsr	Put_over		; Put the string
		bra.s	\dead			; Idem as dead
\no_time_over:

	cmp.b	#EX_DEAD,d1		; Dead
	bne.s	\no_dead
\dead:		tst.w	Life(a6)		; Life > 0 ?
		bne	\first			; Yes so we restart the level
\game_over:
		lea	game_over_str(Pc),a2	; Else print Game-Over
		bsr	Put_over
		clr.w	d0
		move.w	#3,Life(a6)
		bra.s	\start_level		; And quit
\no_dead:
	cmp.b	#NEXT_LEVEL,d1		; Next level ?
	bne	\no_next_level

		moveq	#0,d0
		move.w	Level_no(a6),d0
		addq.w	#1,d0			; Level_no++
\start_level:
		move.w	d0,Level_no(a6)
		move.l	World_adr(a6),a0	; A0 -> World
		cmp.w	WORLD_NBR(a0),d0	; Level_no = level_max
		beq.s	\done			; Yes so quit !
			add.w	d0,d0			; Else we will search the starting-point
			move.w	WORLD_TABLE(a0,d0.w),d0		; Offset
			add.l	d0,a0			; A0 -> Level
			move.l	(START_X)(a0),Start_x(a6) ; Copy the starting-point
			bsr	Save_game		; Save the game
			bra	\first			; Start the next level
\done:
		tst.b	WORLD_NEXT(a0)
		beq.s	\real_done
			move.l	Save_adr(a6),a1
			move.l	WORLD_NEXT(a0),Sv_world_name(a1)
			move.l	WORLD_NEXT+4(a0),Sv_world_name+4(a1)
			clr.w	Level_no(a6)
			; World found ?
			addq.l	#2,a0
			move.l	a0,-(a7)
			bsr	search
			move	tios::SYM_ENTRY.hVal(a0),d1	;Get handle of file in d1
			move.l	(a7)+,a0
			tst.w	d0
			beq	File_not_found
			tios::DEREF d1,a0
			addq.l	#2,a0
			move.l	(a0)+,d0
			cmp.l	#(NEXT_SIGNATURE),d0
			bne	File_invalide
			move.l	a0,World_adr(a6)
			; Copie point de depart
			moveq	#0,d0
			move.w	WORLD_TABLE(a0),d0	; Offset
			add.l	d0,a0			; A0 -> Level
			move.l	(START_X)(a0),Start_x(a6) ; Copy the starting-point
			bsr	Save_game		; Save the game
			bra	\first
\real_done:
	lea	the_end_str(Pc),a2	; put 'the end'
	bsr.s 	Put_over
	moveq	#0,d1
	bsr	put_image
;	move.l	Screen_1(a6),d0
;	jsr	genlib::set_dscreen_function
;	jsr	genlib::set_dscreen_int
;	lea	Ecran_fin,a1
;	moveq	#0,d0
;	moveq	#0,d1
;	move.l	#65536,d4
;	move.l	#65536,d5
;	tst.b	Calc(a6)
;	bne.s	\d
;	move.l	#(65536*240/160),d4
;	move.l	#(65536*100/128),d5
;\d:	jsr	genlib::cls
;	jsr	genlib::put_big_sprite_zoom
;	jsr	genlib::wait_a_key

	bra	memory_error		; Quit
\no_next_level:
	bra	Overflow		; Exit <> ? => An error !

; Input : a0 -> String
Put_over:
	jsr	tios::ScreenClear
	move.w	#LCD_WIDTH-9*9,d0	; To center on 92+ and 89
	move.w	#LCD_HEIGHT-15,d1
	lsr.w	#1,d0
	lsr.w	#1,d1
	moveq	#4,d2			
	move.l	a2,a0
	bsr	put_string		; Put the string
	jsr	genlib::set_LCD_MEM
	jmp	genlib::wait_a_key
